# $Id: valgrind.spec,v 1.1 2003/08/26 17:49:43 rexdieter Exp $

## kde-redhat macros
%define rhversion %(perl -pe '/(\\d+)\\.?(\\d)?/; $_="$1".($2||0)' /etc/redhat-release)

%define fedora_release .fdr.3%{!?_without_dist:.rh%{rhversion}}

Summary: Valgrind Memory Debugger
Name:	 valgrind
Epoch:	 0
Version: 1.9.6
Release: 2%{fedora_release}
License: GPL
Group:	 Development/Debuggers
Url: 	 http://developer.kde.org/~sewardj/ 
Source:	 http://developer.kde.org/~sewardj/valgrind-1.9.6.tar.bz2
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root

Source1: %{name}.req
Source900: gccver.c
BuildRequires: gcc

#
# Sent email to the author. Getting the following dependencies being 
# unresolved, libc.so.6(GLIBC_PRIVATE) is needed by 
# valgrind. His response was install from source.
%define __find_requires %{SOURCE1}
#
# From the README, do not strip the shared libraries
%define __os_install_post /usr/lib/rpm/brp-compress 

## make --workaround-gcc296-bugs=yes the default
Patch1: valgrind-1.9.6-gcc296-default.patch

%description 
Valgrind is a GPL'd tool to help you find memory-management problems
in your programs. When a program is run under Valgrind's supervision,
all reads and writes of memory are checked, and calls to
malloc/new/free/delete are intercepted. As a result, Valgrind can
detect problems such as:

- Use of uninitialised memory 
- Reading/writing memory after it has been free'd 
- Reading/writing off the end of malloc'd blocks 
- Reading/writing inappropriate areas on the stack 
- Memory leaks -- where pointers to malloc'd blocks are lost forever
- Passing of uninitialised and/or unaddressible memory to system calls
- Mismatched use of malloc/new/new [] vs free/delete/delete []
- Some abuses of the POSIX Pthreads API

$Revision: 1.1 $


%prep
%setup -q 

gcc -o gccver %{SOURCE900}
if [ "`./gccver -v`" == "2.96" ]; then
%patch1 -p1 -b .gcc296-default
fi


%build

# %%configure/make does not work if CFLAGS is set...
# IMO, it is a Makefile/configure bug.
%define optflags %{nil}
%configure
unset CFLAGS CXXFLAGS FFLAGS

make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT 
%makeinstall

## remove unpackaged files
# non-standard doc files
rm -rf $RPM_BUILD_ROOT%{_docdir}/%{name}


%files
%defattr(-,root,root,-)
%doc docs/*.html */docs/*.html
%{_bindir}/*
%{_libdir}/%{name}
%{_includedir}/%{name}


%clean
rm -rf $RPM_BUILD_ROOT 


%changelog
* Mon Aug 18 2003 Rex Dieter <rexdieter at sf.net> 0:1.9.6-2.fdr.3
- hmm... Epoch got lost somewhere... put back (Epoch *would* have fixed
  the -1 release problem below...)

* Fri Jun 20 2003 Bob Tanner <tanner@real-time.com> 0:1.9.6-2.fdr.2
- Several version of the -1 release from Real Time out there and got
  "bug" complaints, so bumbed release number to "fix" it.

* Fri May 23 2003 Rex Dieter <rexdieter at sf.net> 0:1.9.6-0.fdr.2
- fix for Requires: libc.so(GLIBC_PRIVATE) issue.

* Fri May 23 2003 Rex Dieter <rexdieter at sf.net> 0:1.9.6-0.fdr.1
- make --workaround-gcc296-bugs default only if built
  with gcc296.

* Thu May 22 2003 Rex Dieter <rexdieter at sf.net> 0:1.9.6-0.fdr.0
- fix/use %%configure macro 
- remove use of %%find_lang (there are no locale files)
- remove %%post/%%postun -p ldconfig (no shared libs)
- fedora'ize
- make --workaround-gcc296-bugs default on rh73.
- add cvs tags to specfile.

* Wed May 07 2003 Bob Tanner <tanner@real-time.com>
+ valgrind-1.9.6-1.realtime
- upgraded to 1.9.6

* Mon Oct 28 2002 Bob Tanner <tanner@real-time.com>
+ valgrind-1.0.4-3.realtime
- compiles with gcc-3.2
- linked against kde-3.0.4 and qt-3.0.5
- hack to fix dependencies problems, see commments at the top of the file
- README states do not strip the shared libraries, override macro

* Wed Oct 16 2002 Bob Tanner <tanner@real-time.com>
+ valgrind-1.0.4-2.realtime
- upgraded to 1.0.4

* Sun Jul 28 2002 Bob Tanner <tanner@real-time.com>
+ valgrind-1.0.0-realtime.1
- change Source0 to .bz2 from .gz
- use %configure and %makeinstall macros

